<template>
  <div>
    <v-row dense style="overflow-y: auto">
      <GCol cols="12">
        <div class="mt-4">
          <DccLocalizedTextarea
            v-model="value.name"
            i18n="dcc.common.softwareType.name"
            validate="required"
          />
        </div>
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.release"
          i18n="dcc.common.softwareType.release"
          validate="required notEmptyStringType"
        />
      </GCol>
      <GCol cols="12">
        <GAutocomplete
          v-model="type"
          i18n="dcc.common.softwareType.type.title"
          :items="typeItems"
          :item-text="(el) => $t(`dcc.common.softwareType.type.${el.value}`)"
          clearable
        />
      </GCol>
      <GCol cols="12">
        <RichContent
          v-if="value.description"
          ref="richContentType"
          v-model="value.description"
          i18n="dcc.common.richContentType.description.title"
          optional
          level="second"
          @delete="deleteRichContent"
        />
      </GCol>
    </v-row>
  </div>
</template>

<script>
import { DCCXMLElement, RichContentType } from "@d-ptb/dcc-js";
import DccLocalizedTextarea from "@/components/App/Form/XML/DccLocalizedTextarea";
import XmlTextField from "@/components/App/Form/XML/XmlTextField";
import GAutocomplete from "@/components/App/Form/gAutocomplete";
import RichContent from "@/components/DCC/Common/RichContent";
import GCol from "@/components/App/Common/GCol";
import { insertIf } from "~/assets/util/general";
export default {
  name: "Software",
  components: {
    GCol,
    RichContent,
    GAutocomplete,
    XmlTextField,
    DccLocalizedTextarea,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
  },
  data() {
    return {
      typeItems: [
        { value: "application" },
        { value: "bios" },
        { value: "driver" },
        { value: "editor" },
        { value: "firmware" },
        { value: "library" },
        { value: "os" },
        { value: "other" },
      ],
    };
  },
  computed: {
    availableElements() {
      return [
        {
          text: this.$t("dcc.common.richContentType.description.title"),
          value: "richContentType",
          addElement: () => this.addElement("richContentType"),
        },
      ].filter((x) => !this.blacklist.includes(x.value));
    },
    blacklist() {
      return [...insertIf(this.value.description, "richContentType")];
    },
    type: {
      get() {
        return this.value.type ? this.value.type._text : "";
      },
      set(val) {
        if (val) {
          this.value.type = new DCCXMLElement({ _text: val });
        } else {
          this.value.type = null;
        }
      },
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "richContentType":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
      this.$nextTick(() => {
        this.$refs[element].$el.scrollIntoView({
          behavior: "smooth",
        });
      });
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
